# Author: Tom Werner
# Email: tom@mojombo.com
# URL: http://www.mojombo.com/
# Date: 2004-07-18
# Version 1.1
# Tested on MT 2.6.x, 3.0d
#
# Documentation: http://www.gravatar.com/implement.php#section_2_4
#
# CHANGES
# 2004-11-14 Fixed URL ampersand XHTML encoding issue by updating to use proper entity

use MT::Template::Context;

MT::Template::Context->add_tag(CommentBodyPlusGravatar => sub {
	use URI::Escape;
	use Digest::MD5 qw(md5_hex);
 
	my ($ctx, $args) = @_;
	MT::Template::Context::sanitize_on($arg);
	my $tag = $ctx->stash('tag');
	my $c = $ctx->stash($tag =~ /Preview/ ? 'comment_preview' : 'comment')
	or return $ctx->_no_comment_error('MT' . $tag);
	my $blog = $ctx->stash('blog');
	my $email = $c->email;
	my $text = defined $c->text ? $c->text : '';
	my $class = exists $args->{class} ? $args->{class} : 'gravatar';
	#my $sitelink = exists $args->{sitelink} ? $args->{sitelink} : 0;
	$text = MT::Util::munge_comment($text, $blog);

	my $convert_breaks = exists $arg->{convert_breaks} ?
        $arg->{convert_breaks} :
        $blog->convert_paras_comments;

	my $gurl = "http://www.gravatar.com/avatar/".md5_hex(lc $email);
	$gurl .= exists $args->{rating} ? "&amp;r=".$args->{rating} : "";
	$gurl .= exists $args->{size} ? "&amp;s=".$args->{size} : "";
	$gurl .= exists $args->{default} ? "&amp;d=".uri_escape($args->{default}) : "";

	#my $url = defined $c->url ? $c->url : 0;
    #$url = MT::Util::remove_html($url);

	$gtag = "<img class=\"".$class."\" src=\"".$gurl."\" alt=\"\" />";
	#if($sitelink && $url)
	#{
	#	$gtag = "<a href=\"".$url."\">$gtag</a>";
	#}

	$text = $convert_breaks ?
        MT->apply_text_filters($text, $blog->comment_text_filters, $ctx) :
       $text;

	$text =~ s/<p>(.*)/<p>$gtag$1/;

	return $text;

});